Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLDocument.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLDocument.java	(revision 1223)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLDocument.java	(revision 1264)
@@ -41,12 +41,13 @@
     }
 
-    /*
-     * (non-Javadoc)
-     * 
-     * @see java.lang.Object#toString()
+    /**
+     * <p>
+     * TODO: comment
+     * </p>
+     *
+     * @return
      */
-    @Override
-    public String toString() {
-        return "Document(" + getPath() + ", \"" + getTitle() + "\")";
+    public String getPath() {
+        return ((HTMLDocumentSpec) super.getSpecification()).getPath();
     }
 
@@ -79,15 +80,4 @@
      * @return
      */
-    String getPath() {
-        return ((HTMLDocumentSpec) super.getSpecification()).getPath();
-    }
-
-    /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
-     * @return
-     */
     String getTitle() {
         return ((HTMLDocumentSpec) super.getSpecification()).getTitle();
Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLDocumentSpec.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLDocumentSpec.java	(revision 1223)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLDocumentSpec.java	(revision 1264)
@@ -94,4 +94,12 @@
     }
 
+    /* (non-Javadoc)
+     * @see java.lang.Object#toString()
+     */
+    @Override
+    public String toString() {
+        return "Document(" + getPath() + ", \"" + getTitle() + "\")";
+    }
+
     /**
      * <p>
Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLGUIElement.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLGUIElement.java	(revision 1223)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLGUIElement.java	(revision 1264)
@@ -63,4 +63,14 @@
      * (non-Javadoc)
      * 
+     * @see java.lang.Object#toString()
+     */
+    @Override
+    public String toString() {
+        return super.getSpecification().toString();
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
      * @see
      * de.ugoe.cs.autoquest.eventcore.guimodel.IGUIElement#updateSpecification(de.ugoe.cs.autoquest.eventcore
Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLPageElement.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLPageElement.java	(revision 1223)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLPageElement.java	(revision 1264)
@@ -51,21 +51,35 @@
     }
 
-    /*
-     * (non-Javadoc)
-     * 
-     * @see java.lang.Object#toString()
+    /**
+     * <p>
+     * TODO: comment
+     * </p>
+     *
+     * @return
      */
-    @Override
-    public String toString() {
-        String str = getTagName();
-        
-        if ((getHtmlId() != null) && (!"".equals(getHtmlId()))) {
-            str += "(id=\"" + getHtmlId() + "\")";
-        }
-        else {
-            str += "[" + getIndex() + "]";
-        }
-        
-        return str;
+    public String getTagName() {
+        return ((HTMLPageElementSpec) super.getSpecification()).getTagName();
+    }
+
+    /**
+     * <p>
+     * TODO: comment
+     * </p>
+     *
+     * @return
+     */
+    public String getHtmlId() {
+        return ((HTMLPageElementSpec) super.getSpecification()).getHtmlId();
+    }
+
+    /**
+     * <p>
+     * TODO: comment
+     * </p>
+     *
+     * @return
+     */
+    public int getIndex() {
+        return ((HTMLPageElementSpec) super.getSpecification()).getIndex();
     }
 
@@ -91,36 +105,3 @@
     }
 
-    /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
-     * @return
-     */
-    String getTagName() {
-        return ((HTMLPageElementSpec) super.getSpecification()).getTagName();
-    }
-
-    /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
-     * @return
-     */
-    String getHtmlId() {
-        return ((HTMLPageElementSpec) super.getSpecification()).getHtmlId();
-    }
-
-    /**
-     * <p>
-     * TODO: comment
-     * </p>
-     *
-     * @return
-     */
-    int getIndex() {
-        return ((HTMLPageElementSpec) super.getSpecification()).getIndex();
-    }
-
 }
Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLPageElementSpec.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLPageElementSpec.java	(revision 1223)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLPageElementSpec.java	(revision 1264)
@@ -81,7 +81,7 @@
                 return false;
             }
-            else if (!page.getSimilarity(otherSpec.page)) {
+            /*else if (!page.getSimilarity(otherSpec.page)) {
                 return false;
-            }
+            }*/
             else if (!tagName.equals(otherSpec.tagName)) {
                 return false;
@@ -97,4 +97,21 @@
         
         return false;
+    }
+
+    /* (non-Javadoc)
+     * @see java.lang.Object#toString()
+     */
+    @Override
+    public String toString() {
+        String str = getTagName();
+        
+        if ((getHtmlId() != null) && (!"".equals(getHtmlId()))) {
+            str += "(id=\"" + getHtmlId() + "\")";
+        }
+        else {
+            str += "[" + getIndex() + "]";
+        }
+        
+        return str;
     }
 
Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLServer.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLServer.java	(revision 1223)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLServer.java	(revision 1264)
@@ -49,21 +49,4 @@
      * (non-Javadoc)
      * 
-     * @see java.lang.Object#toString()
-     */
-    @Override
-    public String toString() {
-        String str = "Server(" + getHost();
-
-        if (getPort() > -1 ) {
-            str += ":" + getPort();
-        }
-        
-        str += ")";
-        return str;
-    }
-
-    /*
-     * (non-Javadoc)
-     * 
      * @see de.ugoe.cs.autoquest.plugin.html.guimodel.HTMLGUIElement#getElementDescriptor()
      */
Index: trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLServerSpec.java
===================================================================
--- trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLServerSpec.java	(revision 1223)
+++ trunk/autoquest-plugin-html/src/main/java/de/ugoe/cs/autoquest/plugin/html/guimodel/HTMLServerSpec.java	(revision 1264)
@@ -80,4 +80,19 @@
     }
 
+    /* (non-Javadoc)
+     * @see java.lang.Object#toString()
+     */
+    @Override
+    public String toString() {
+        String str = "Server(" + getHost();
+
+        if (getPort() > -1 ) {
+            str += ":" + getPort();
+        }
+        
+        str += ")";
+        return str;
+    }
+
     /**
      * <p>