Index: trunk/autoquest-plugin-html-test/src/test/resources/htmlmonitor_testtrace_1.xml
===================================================================
--- trunk/autoquest-plugin-html-test/src/test/resources/htmlmonitor_testtrace_1.xml	(revision 1069)
+++ trunk/autoquest-plugin-html-test/src/test/resources/htmlmonitor_testtrace_1.xml	(revision 1279)
@@ -16,4 +16,124 @@
  <param name="parent" value="h86vXoTkkOrxPJvwFGujZyUjp0nFxzYmOtMrHz500vZAAxC8BSUSVDPd9n3fW20TpuoYyduSITXbQTe3HGGYzA=="/>
 </component>
+<component id="IqqUnwzS3twFrjNEAUKWBJpweVh/BCQNQqWOJ7lWz8Sevl1DYKyYYy1vSJxVnnYR3kMWdYdnJ4hJ1ZSBNvYolQ==">
+ <param name="tagname" value="html"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="RN9UvPsVVUbCHJ1cAOMIRiO4f081bg4mviZhJC4UfsmHHm5WMIjOt1gkEVJxOCGUFw0jb5D3seQTLrbRvixYmw=="/>
+</component>
+<component id="h86vXoTkkOrxPJvwFGujZyUjp0nFxzYmOtMrHz500vZAAxC8BSUSVDPd9n3fW20TpuoYyduSITXbQTe3HGGYzA==">
+ <param name="tagname" value="head"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="IqqUnwzS3twFrjNEAUKWBJpweVh/BCQNQqWOJ7lWz8Sevl1DYKyYYy1vSJxVnnYR3kMWdYdnJ4hJ1ZSBNvYolQ=="/>
+</component>
+<component id="CtZKltwzZ7+x5+nx8lTLBeRxNKaya9S2pyfTFvMibEpNy2w2R8hIPXNOhcqFQp6fufjcASzBb3b899Zel3aAAQ==">
+ <param name="tagname" value="script"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="h86vXoTkkOrxPJvwFGujZyUjp0nFxzYmOtMrHz500vZAAxC8BSUSVDPd9n3fW20TpuoYyduSITXbQTe3HGGYzA=="/>
+</component>
+<component id="ZTvDsD/CzvnrudmS16OhgdWk06Jy+rXgU5z4lMWMRj9/3u+r5wqQUkU9Dw1/gYzIL7pZKcNSLLHpO0DzpIo9fQ==">
+ <param name="tagname" value="script"/>
+ <param name="index" value="2"/>
+ <param name="parent" value="h86vXoTkkOrxPJvwFGujZyUjp0nFxzYmOtMrHz500vZAAxC8BSUSVDPd9n3fW20TpuoYyduSITXbQTe3HGGYzA=="/>
+</component>
+<component id="OahLE2sJAmolfdlTwY/LzEBm2EDhu0Q6tqkCj1r+Upv9d0a6/KgBaxPMYTe9EGILNpcbm9WZohbQfdqJakxG5Q==">
+ <param name="tagname" value="body"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="IqqUnwzS3twFrjNEAUKWBJpweVh/BCQNQqWOJ7lWz8Sevl1DYKyYYy1vSJxVnnYR3kMWdYdnJ4hJ1ZSBNvYolQ=="/>
+</component>
+<component id="9Ed8y91D9+l5a4zKtGSFJPosy//OXF2Tj2pmC7jO+5r1iqGBuMjlRRhiITsHOUuQbJNqL1bbt/k8h0shZJsbWw==">
+ <param name="tagname" value="h1"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="OahLE2sJAmolfdlTwY/LzEBm2EDhu0Q6tqkCj1r+Upv9d0a6/KgBaxPMYTe9EGILNpcbm9WZohbQfdqJakxG5Q=="/>
+</component>
+<component id="Y6PN1LUVUC9L+RrpFp72C6xMt+lhDjDhVLOfFoJ/h173Xl9cikyXO+g9UwnX5PqiMPu0EK9rxADcg+HVZsFsbQ==">
+ <param name="tagname" value="form"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="OahLE2sJAmolfdlTwY/LzEBm2EDhu0Q6tqkCj1r+Upv9d0a6/KgBaxPMYTe9EGILNpcbm9WZohbQfdqJakxG5Q=="/>
+</component>
+<component id="gCu0QxzFASfSF7rScLhNRolN613LuJEASzlG5W9B61G0t/wKinFLiz9b61WYuB522JCkEQNuGSUSSFyVsZMl+Q==">
+ <param name="tagname" value="table"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="Y6PN1LUVUC9L+RrpFp72C6xMt+lhDjDhVLOfFoJ/h173Xl9cikyXO+g9UwnX5PqiMPu0EK9rxADcg+HVZsFsbQ=="/>
+</component>
+<component id="HjnTtYFaEQjs+S/hu/C2TxcpKpJ7s9RQ2JKwmGcGArrWSYwrnYTrA7ffBhCBbF25wHJhGycF+xRDE1mzKhaREQ==">
+ <param name="tagname" value="tbody"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="gCu0QxzFASfSF7rScLhNRolN613LuJEASzlG5W9B61G0t/wKinFLiz9b61WYuB522JCkEQNuGSUSSFyVsZMl+Q=="/>
+</component>
+<component id="kD0akjZR6COBUh1Cr3dsaR2ti23J37C5jmgduSrNp2tumLrjW1sjPLzRyMydx1s7H8YcWbDNO1IytRomOy0Niw==">
+ <param name="tagname" value="tr"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="HjnTtYFaEQjs+S/hu/C2TxcpKpJ7s9RQ2JKwmGcGArrWSYwrnYTrA7ffBhCBbF25wHJhGycF+xRDE1mzKhaREQ=="/>
+</component>
+<component id="BDclTyhEWN62cIwpzpTH93CrimtXqR++xHLHpkhr7s2mGLMKjl6vt1jVDz+6bnPK5Q0fU0OSL5bn5DIfYbp69g==">
+ <param name="tagname" value="th"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="kD0akjZR6COBUh1Cr3dsaR2ti23J37C5jmgduSrNp2tumLrjW1sjPLzRyMydx1s7H8YcWbDNO1IytRomOy0Niw=="/>
+</component>
+<component id="N+2MUqCbnVTcF3U/duJY+8QpfjMNGehfAIeOF7dHco6T2QH/J0vo9RsdDsjkaQwD7I6Q0NzRSd+QJ/4jhZFbLQ==">
+ <param name="tagname" value="th"/>
+ <param name="index" value="2"/>
+ <param name="parent" value="kD0akjZR6COBUh1Cr3dsaR2ti23J37C5jmgduSrNp2tumLrjW1sjPLzRyMydx1s7H8YcWbDNO1IytRomOy0Niw=="/>
+</component>
+<component id="3Amho279IVN0Ey2/pnJZq8Qw0KD0WMgghdUZsM764dbaTWQSvQSbYtJ4NI1pqxTgK+oqd72gK3UsY9pw529vMg==">
+ <param name="tagname" value="tr"/>
+ <param name="index" value="2"/>
+ <param name="parent" value="HjnTtYFaEQjs+S/hu/C2TxcpKpJ7s9RQ2JKwmGcGArrWSYwrnYTrA7ffBhCBbF25wHJhGycF+xRDE1mzKhaREQ=="/>
+</component>
+<component id="aFk4jNvrJ0sa/SwnFBbKSfaWf0JZPaBSfT/y2mvafu8cZSOhm20ykZ4vGTef29aKlbLBXTEocNI4ODlxvm+hXg==">
+ <param name="tagname" value="td"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="3Amho279IVN0Ey2/pnJZq8Qw0KD0WMgghdUZsM764dbaTWQSvQSbYtJ4NI1pqxTgK+oqd72gK3UsY9pw529vMg=="/>
+</component>
+<component id="SlNCDsFGs3QlhnV59N2pi0ixZVuEjqZOx01hmv2naPqIbL3UML+0C82Gj+2aQ7FeqX7U90gk4bxrigsga+9lyw==">
+ <param name="tagname" value="td"/>
+ <param name="index" value="2"/>
+ <param name="parent" value="3Amho279IVN0Ey2/pnJZq8Qw0KD0WMgghdUZsM764dbaTWQSvQSbYtJ4NI1pqxTgK+oqd72gK3UsY9pw529vMg=="/>
+</component>
+<component id="Q/jTRf/j5EpxAmOo/N2pfGXblpqQEKLbug5XpKiB/0G5H1MgXcV9H7y0/k0KG1i5YWgDT/Ws5qicsvpYffWe6A==">
+ <param name="tagname" value="input_text"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="SlNCDsFGs3QlhnV59N2pi0ixZVuEjqZOx01hmv2naPqIbL3UML+0C82Gj+2aQ7FeqX7U90gk4bxrigsga+9lyw=="/>
+</component>
+<component id="TBJVtmPiQC0+zTTMmrFn7eavPkU+C27UQkBvb8aI/IDWHus9kW6J7zToF1hqF+LhDLNY3fvLXOIwN64LXy+BqA==">
+ <param name="tagname" value="tr"/>
+ <param name="index" value="3"/>
+ <param name="parent" value="HjnTtYFaEQjs+S/hu/C2TxcpKpJ7s9RQ2JKwmGcGArrWSYwrnYTrA7ffBhCBbF25wHJhGycF+xRDE1mzKhaREQ=="/>
+</component>
+<component id="2bfLWPsPC4AzDpmzCqhBZVixZvPP60cA1t13wVCPhBx5i6Mjfw11LIvx68BfisrL+lV3fMnvXArnxl/nwpdmEQ==">
+ <param name="tagname" value="td"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="TBJVtmPiQC0+zTTMmrFn7eavPkU+C27UQkBvb8aI/IDWHus9kW6J7zToF1hqF+LhDLNY3fvLXOIwN64LXy+BqA=="/>
+</component>
+<component id="rgrJ3qG9nKTjfs1Cb5UTOPWul3pmgetbKVyfT/mOiIIQ68h2T1NDzfrW1VovNOTRMtZPA1lE5fb/fjIzG2cHsg==">
+ <param name="tagname" value="td"/>
+ <param name="index" value="2"/>
+ <param name="parent" value="TBJVtmPiQC0+zTTMmrFn7eavPkU+C27UQkBvb8aI/IDWHus9kW6J7zToF1hqF+LhDLNY3fvLXOIwN64LXy+BqA=="/>
+</component>
+<component id="AiciBvB9N5YdjEhMBKDU9iBMSYBJuGKfJtR8sXGRgEMHIXJOLMnWGaNIX2M0R0DFD2a4YRUNehWG/ahP2IyYQg==">
+ <param name="tagname" value="textarea"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="rgrJ3qG9nKTjfs1Cb5UTOPWul3pmgetbKVyfT/mOiIIQ68h2T1NDzfrW1VovNOTRMtZPA1lE5fb/fjIzG2cHsg=="/>
+</component>
+<component id="Y5+tr0eGbjfpkf0/bXIvDw3yBUQnAwpUCA6d5KRGo/ts9r9Xi89WMKmCdKO0T8HaXvn1sXwOsOwGASyoLu00cQ==">
+ <param name="tagname" value="tr"/>
+ <param name="index" value="4"/>
+ <param name="parent" value="HjnTtYFaEQjs+S/hu/C2TxcpKpJ7s9RQ2JKwmGcGArrWSYwrnYTrA7ffBhCBbF25wHJhGycF+xRDE1mzKhaREQ=="/>
+</component>
+<component id="5d1P2UUEObmMhQhwYuJ5g0oDHqRxSj03XkbVav56m7T+R0oGQCp8mkEVPO/Tb8ju+Sob1WNF1InI607rAvt0Jg==">
+ <param name="tagname" value="td"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="Y5+tr0eGbjfpkf0/bXIvDw3yBUQnAwpUCA6d5KRGo/ts9r9Xi89WMKmCdKO0T8HaXvn1sXwOsOwGASyoLu00cQ=="/>
+</component>
+<component id="g3AxjzW3aFRXxGUmz7H3tyER54EDGAQLWNwNSmclqRjU78Lvib5EDn7L8Jl67yID5xOgC3iMLtuCOucoeZ102w==">
+ <param name="tagname" value="td"/>
+ <param name="index" value="2"/>
+ <param name="parent" value="Y5+tr0eGbjfpkf0/bXIvDw3yBUQnAwpUCA6d5KRGo/ts9r9Xi89WMKmCdKO0T8HaXvn1sXwOsOwGASyoLu00cQ=="/>
+</component>
+<component id="GEWwCYEj6REdKvD5PKMJRmf7Hoe98ZotJtr9GUoQwayoCZ+AGYdWr4sjoxW8cPqXY941YALqCMyPgp3S7waYgA==">
+ <param name="tagname" value="input_button"/>
+ <param name="index" value="1"/>
+ <param name="parent" value="g3AxjzW3aFRXxGUmz7H3tyER54EDGAQLWNwNSmclqRjU78Lvib5EDn7L8Jl67yID5xOgC3iMLtuCOucoeZ102w=="/>
+</component>
 <component id="6+HHIC3R288zTD+UMh/vyD4Fh9v7TxI7zL5+B4buXKbCxxRCsQN2hoIFYYHu3fwpl7o2PVIXEzB8T0pN6MGyGg==">
  <param name="tagname" value="title"/>