Index: trunk/autoquest-core-usageprofiles-test/src/test/java/de/ugoe/cs/autoquest/usageprofiles/DefaultSymbolMapTest.java
===================================================================
--- trunk/autoquest-core-usageprofiles-test/src/test/java/de/ugoe/cs/autoquest/usageprofiles/SymbolMapTest.java	(revision 1251)
+++ trunk/autoquest-core-usageprofiles-test/src/test/java/de/ugoe/cs/autoquest/usageprofiles/DefaultSymbolMapTest.java	(revision 1282)
@@ -17,5 +17,7 @@
 import static org.junit.Assert.*;
 
+import java.util.HashSet;
 import java.util.Iterator;
+import java.util.Set;
 
 import org.junit.Test;
@@ -29,10 +31,9 @@
  * @author Patrick Harms
  */
-public class SymbolMapTest {
+public class DefaultSymbolMapTest {
 
     @Test
     public void testSymbolMap_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         assertNotNull(symbolMap);
@@ -42,10 +43,9 @@
     @Test
     public void testSymbolMap_2() {
-        SymbolMap<String, String> symbolMap1 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap1 = new DefaultSymbolMap<String, String>();
         
         symbolMap1.addSymbol("symbol", "value");
         
-        SymbolMap<String, String> symbolMap2 = new SymbolMap<String, String>(symbolMap1);
+        SymbolMap<String, String> symbolMap2 = new DefaultSymbolMap<String, String>(symbolMap1);
         
         assertNotNull(symbolMap2);
@@ -55,16 +55,10 @@
     @Test(expected = java.lang.IllegalArgumentException.class)
     public void testSymbolMap_3() throws Exception {
-        new SymbolMap<String, String>((DefaultSymbolComparator<String>) null);
-    }
-
-    @Test(expected = java.lang.IllegalArgumentException.class)
-    public void testSymbolMap_4() throws Exception {
-        new SymbolMap<String, String>((SymbolMap<String, String>) null);
+        new DefaultSymbolMap<String, String>((SymbolMap<String, String>) null);
     }
     
     @Test
     public void testAddSymbol_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -76,6 +70,5 @@
     @Test
     public void testAddSymbol_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -96,6 +89,5 @@
     @Test
     public void testAddSymbol_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -123,6 +115,5 @@
     @Test(expected = java.lang.IllegalArgumentException.class)
     public void testAddSymbol_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol(null, null);
@@ -131,6 +122,5 @@
     @Test
     public void testSize_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         assertEquals(0, symbolMap.size());
@@ -139,6 +129,5 @@
     @Test
     public void testSize_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -149,6 +138,5 @@
     @Test
     public void testSize_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -163,6 +151,5 @@
     @Test
     public void testSize_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -182,6 +169,5 @@
     @Test
     public void testSize_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -200,6 +186,5 @@
     @Test
     public void testIsEmpty_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         assertTrue(symbolMap.isEmpty());
@@ -208,6 +193,5 @@
     @Test
     public void testIsEmpty_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -218,6 +202,5 @@
     @Test
     public void testIsEmpty_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -232,6 +215,5 @@
     @Test
     public void testIsEmpty_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -251,6 +233,5 @@
     @Test
     public void testIsEmpty_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -269,6 +250,5 @@
     @Test
     public void testContainsSymbol_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         assertFalse(symbolMap.containsSymbol("symbol"));
@@ -277,6 +257,5 @@
     @Test
     public void testContainsSymbol_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -287,6 +266,5 @@
     @Test
     public void testContainsSymbol_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -303,6 +281,5 @@
     @Test
     public void testContainsSymbol_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -324,6 +301,5 @@
     @Test
     public void testContainsSymbol_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -352,6 +328,5 @@
     @Test(expected = java.lang.IllegalArgumentException.class)
     public void testContainsSymbol_6() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.containsSymbol(null);
@@ -360,6 +335,5 @@
     @Test
     public void testGetValue_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         assertNull(symbolMap.getValue("symbol"));
@@ -368,6 +342,5 @@
     @Test
     public void testGetValue_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -378,6 +351,5 @@
     @Test
     public void testGetValue_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", null);
@@ -388,6 +360,5 @@
     @Test
     public void testGetValue_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -404,6 +375,5 @@
     @Test
     public void testGetValue_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -430,6 +400,5 @@
     @Test
     public void testGetValue_6() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -458,6 +427,5 @@
     @Test(expected = java.lang.IllegalArgumentException.class)
     public void testGetValue_7() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.getValue(null);
@@ -466,6 +434,5 @@
     @Test
     public void testRemoveSymbol_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         assertNull(symbolMap.removeSymbol("symbol"));
@@ -474,6 +441,5 @@
     @Test
     public void testRemoveSymbol_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -485,6 +451,5 @@
     @Test
     public void testRemoveSymbol_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", null);
@@ -496,6 +461,5 @@
     @Test
     public void testRemoveSymbol_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -514,6 +478,5 @@
     @Test
     public void testRemoveSymbol_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -542,6 +505,5 @@
     @Test
     public void testRemoveSymbol_6() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -572,6 +534,5 @@
     @Test(expected = java.lang.IllegalArgumentException.class)
     public void testRemoveSymbol_7() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.removeSymbol(null);
@@ -580,6 +541,5 @@
     @Test
     public void testGetSymbols_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         assertNotNull(symbolMap.getSymbols());
@@ -589,6 +549,5 @@
     @Test
     public void testGetSymbols_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -601,6 +560,5 @@
     @Test
     public void testGetSymbols_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", null);
@@ -613,11 +571,12 @@
     @Test
     public void testGetSymbols_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
-        
-        int entryCount = 2000;
-        
-        for (int i = 0; i < entryCount; i++) {
-            symbolMap.addSymbol("symbol" + i, "value" + i);
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
+        Set<String> expectedSymbols = new HashSet<String>();
+        
+        int entryCount = 2000;
+        
+        for (int i = 0; i < entryCount; i++) {
+            symbolMap.addSymbol("symbol" + i, "value" + i);
+            expectedSymbols.add("symbol" + i);
         }
         
@@ -628,7 +587,8 @@
         for (int i = 0; i < entryCount; i++) {
             assertTrue(iterator.hasNext());
-            assertEquals("symbol" + i, iterator.next());
-        }
-        
+            expectedSymbols.remove(iterator.next());
+        }
+        
+        assertTrue(expectedSymbols.isEmpty());
         assertFalse(iterator.hasNext());
     }
@@ -636,6 +596,6 @@
     @Test
     public void testGetSymbols_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
+        Set<String> expectedSymbols = new HashSet<String>();
         
         int entryCount = 2000;
@@ -644,7 +604,9 @@
             if (i % 7 == 0) {
                 symbolMap.addSymbol("symbol" + i, "value" + i);
+                expectedSymbols.add("symbol" + i);
             }
             else {
                 symbolMap.addSymbol("symbol" + i, null);
+                expectedSymbols.add("symbol" + i);
             }
         }
@@ -656,7 +618,8 @@
         for (int i = 0; i < entryCount; i++) {
             assertTrue(iterator.hasNext());
-            assertEquals("symbol" + i, iterator.next());
-        }
-        
+            expectedSymbols.remove(iterator.next());
+        }
+        
+        assertTrue(expectedSymbols.isEmpty());
         assertFalse(iterator.hasNext());
     }
@@ -664,15 +627,17 @@
     @Test
     public void testGetSymbols_6() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
-        
-        int entryCount = 2000;
-        
-        for (int i = 0; i < entryCount; i++) {
-            symbolMap.addSymbol("symbol" + i, "value" + i);
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
+        Set<String> expectedSymbols = new HashSet<String>();
+        
+        int entryCount = 2000;
+        
+        for (int i = 0; i < entryCount; i++) {
+            symbolMap.addSymbol("symbol" + i, "value" + i);
+            expectedSymbols.add("symbol" + i);
         }
         
         for (int i = 150; i < (entryCount - 150); i++) {
             symbolMap.removeSymbol("symbol" + i);
+            expectedSymbols.remove("symbol" + i);
         }
         
@@ -683,13 +648,8 @@
         for (int i = 0; i < 2 * 150; i++) {
             assertTrue(iterator.hasNext());
-            
-            if (i < 150) {
-                assertEquals("symbol" + i, iterator.next());
-            }
-            else if (i >= 150){
-                assertEquals("symbol" + (entryCount - 300 + i), iterator.next());
-            }
-        }
-        
+            expectedSymbols.remove(iterator.next());
+        }
+        
+        assertTrue(expectedSymbols.isEmpty());
         assertFalse(iterator.hasNext());
     }
@@ -697,6 +657,5 @@
     @Test
     public void testGetValues_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         assertNotNull(symbolMap.getValues());
@@ -706,6 +665,5 @@
     @Test
     public void testGetValues_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -718,6 +676,5 @@
     @Test
     public void testGetValues_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", null);
@@ -730,11 +687,12 @@
     @Test
     public void testGetValues_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
-        
-        int entryCount = 2000;
-        
-        for (int i = 0; i < entryCount; i++) {
-            symbolMap.addSymbol("symbol" + i, "value" + i);
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
+        Set<String> expectedValues = new HashSet<String>();
+        
+        int entryCount = 2000;
+        
+        for (int i = 0; i < entryCount; i++) {
+            symbolMap.addSymbol("symbol" + i, "value" + i);
+            expectedValues.add("value" + i);
         }
         
@@ -745,7 +703,8 @@
         for (int i = 0; i < entryCount; i++) {
             assertTrue(iterator.hasNext());
-            assertEquals("value" + i, iterator.next());
-        }
-        
+            expectedValues.remove(iterator.next());
+        }
+        
+        assertTrue(expectedValues.isEmpty());
         assertFalse(iterator.hasNext());
     }
@@ -753,6 +712,6 @@
     @Test
     public void testGetValues_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
+        Set<String> expectedValues = new HashSet<String>();
         
         int entryCount = 2000;
@@ -761,7 +720,9 @@
             if (i % 7 == 0) {
                 symbolMap.addSymbol("symbol" + i, "value" + i);
+                expectedValues.add("value" + i);
             }
             else {
                 symbolMap.addSymbol("symbol" + i, null);
+                expectedValues.add(null);
             }
         }
@@ -773,12 +734,8 @@
         for (int i = 0; i < entryCount; i++) {
             assertTrue(iterator.hasNext());
-            if (i % 7 == 0) {
-                assertEquals("value" + i, iterator.next());
-            }
-            else {
-                assertNull(iterator.next());
-            }
-        }
-        
+            expectedValues.remove(iterator.next());
+        }
+        
+        assertTrue(expectedValues.isEmpty());
         assertFalse(iterator.hasNext());
     }
@@ -786,15 +743,17 @@
     @Test
     public void testGetValues_6() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
-        
-        int entryCount = 2000;
-        
-        for (int i = 0; i < entryCount; i++) {
-            symbolMap.addSymbol("symbol" + i, "value" + i);
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
+        Set<String> expectedValues = new HashSet<String>();
+        
+        int entryCount = 2000;
+        
+        for (int i = 0; i < entryCount; i++) {
+            symbolMap.addSymbol("symbol" + i, "value" + i);
+            expectedValues.add("value" + i);
         }
         
         for (int i = 150; i < (entryCount - 150); i++) {
             symbolMap.removeSymbol("symbol" + i);
+            expectedValues.remove("value" + i);
         }
         
@@ -805,13 +764,8 @@
         for (int i = 0; i < 2 * 150; i++) {
             assertTrue(iterator.hasNext());
-            
-            if (i < 150) {
-                assertEquals("value" + i, iterator.next());
-            }
-            else if (i >= 150){
-                assertEquals("value" + (entryCount - 300 + i), iterator.next());
-            }
-        }
-        
+            expectedValues.remove(iterator.next());
+        }
+        
+        assertTrue(expectedValues.isEmpty());
         assertFalse(iterator.hasNext());
     }
@@ -819,6 +773,5 @@
     @Test
     public void testClear_1() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         symbolMap.clear();
@@ -828,6 +781,5 @@
     @Test
     public void testClear_2() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", "value1");
@@ -839,6 +791,5 @@
     @Test
     public void testClear_3() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
             
         symbolMap.addSymbol("symbol1", null);
@@ -850,6 +801,5 @@
     @Test
     public void testClear_4() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -865,6 +815,5 @@
     @Test
     public void testClear_5() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -885,6 +834,5 @@
     @Test
     public void testClear_6() {
-        SymbolMap<String, String> symbolMap =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap = new DefaultSymbolMap<String, String>();
         
         int entryCount = 2000;
@@ -904,9 +852,7 @@
     @Test
     public void testEquals_1() {
-        SymbolMap<String, String> symbolMap1 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
-        
-        SymbolMap<String, String> symbolMap2 =
-                new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap1 = new DefaultSymbolMap<String, String>();
+        
+        SymbolMap<String, String> symbolMap2 = new DefaultSymbolMap<String, String>();
         
         assertTrue(symbolMap1.equals(symbolMap2));
@@ -915,9 +861,7 @@
     @Test
     public void testEquals_2() {
-        SymbolMap<String, String> symbolMap1 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
-            
-        SymbolMap<String, String> symbolMap2 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap1 = new DefaultSymbolMap<String, String>();
+            
+        SymbolMap<String, String> symbolMap2 = new DefaultSymbolMap<String, String>();
             
         symbolMap1.addSymbol("symbol1", "value1");
@@ -928,9 +872,7 @@
     @Test
     public void testEquals_3() {
-        SymbolMap<String, String> symbolMap1 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
-            
-        SymbolMap<String, String> symbolMap2 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap1 = new DefaultSymbolMap<String, String>();
+            
+        SymbolMap<String, String> symbolMap2 = new DefaultSymbolMap<String, String>();
             
         symbolMap1.addSymbol("symbol1", "value1");
@@ -942,9 +884,7 @@
     @Test
     public void testEquals_4() {
-        SymbolMap<String, String> symbolMap1 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap1 = new DefaultSymbolMap<String, String>();
                 
-        SymbolMap<String, String> symbolMap2 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap2 = new DefaultSymbolMap<String, String>();
         
         int entryCount = 200;
@@ -960,9 +900,7 @@
     @Test
     public void testEquals_5() {
-        SymbolMap<String, String> symbolMap1 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap1 = new DefaultSymbolMap<String, String>();
                
-        SymbolMap<String, String> symbolMap2 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap2 = new DefaultSymbolMap<String, String>();
         
         int entryCount = 200;
@@ -986,9 +924,7 @@
     @Test
     public void testEquals_6() {
-        SymbolMap<String, String> symbolMap1 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap1 = new DefaultSymbolMap<String, String>();
                 
-        SymbolMap<String, String> symbolMap2 =
-            new SymbolMap<String, String>(new DefaultSymbolComparator<String>());
+        SymbolMap<String, String> symbolMap2 = new DefaultSymbolMap<String, String>();
         
         int entryCount = 200;